#include "stdafx.h"
#include "GammaManager.h"
#include "GammaManagerDlg.h"
#include <math.h>
#include "HyperLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// 2 bse bse Globals :)
DEVMODE g_SpieleConfig;
float g_fNewgamma;

void CGammaManagerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CSURL1, m_HyperLink1);
	DDX_Control(pDX, IDC_CSURL2, m_HyperLink2);
	DDX_Check(pDX, IDC_AUTOSTART, m_bAutostart);
	DDX_Text(pDX, IDC_RESOLUTION, m_sResolution);
	DDX_Text(pDX, IDC_HOTKEY, m_sHotkey);
}

CGammaManagerDlg::CGammaManagerDlg(CWnd* pParent)
	: CDialog(CGammaManagerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON);
	m_bAutostart = FALSE;
}

void CGammaManagerDlg::OnHotKey(WPARAM wParam, LPARAM lParam)	// Wird aufgerufen, wenn die Hotkeys bettigt werden
{
	if (wParam == 100) 
		{
		g_fNewgamma += m_fGammastep;
		SetGamma(g_fNewgamma);
		}
	else if (wParam == 200) 
		{
		g_fNewgamma -= m_fGammastep;
		SetGamma(g_fNewgamma);
		}
	else if (wParam == 300) 
		{
		g_fNewgamma = (float)1.00;
		SetGamma(g_fNewgamma);
		}
	

	else if (wParam == 400)
		{
		SetHz(g_SpieleConfig.dmDisplayFrequency, g_SpieleConfig.dmPelsWidth, g_SpieleConfig.dmPelsHeight, g_SpieleConfig.dmBitsPerPel);
		}
}

BEGIN_MESSAGE_MAP(CGammaManagerDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_HOTKEY,OnHotKey)				//Incoming Hotkey!
	ON_MESSAGE(WM_TRAY_MESSAGE,OnTrayNotify)	//wenn aufs Trayicon geklickt wird
	ON_WM_SIZE()								//Message, die beim maximieren und minimieren durchkommt
	ON_WM_WINDOWPOSCHANGING()					//Workaround fr "minimiert starten"
	ON_BN_CLICKED(IDC_AUTOSTART, OnAutostart)	//Autostart Checkbox
END_MESSAGE_MAP()

BOOL CGammaManagerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_HyperLink1.SetURL(_T("http://www.counter-strike.de"));
	m_HyperLink2.SetURL(_T("mailto:muff99@counter-strike.de"));
	m_fGammastep = (float)0.10;		// Schrittweite der Gamma
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	UINT iDetection = 0;			// fr die Auflsung-Info
	int	iHotkey = 0;				// Welche Hotkeys solle nverwendte werden? 0 = Strg+Alt, 1 = Alt,. 2 = Shift ...

	//Initialisiert die beiden bsen Globals
	g_fNewgamma = 1.00;
	::ZeroMemory(&g_SpieleConfig, sizeof(g_SpieleConfig));
	if(EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &g_SpieleConfig)) 
		iDetection = 1;	//Aktuelle Displayconfig sichern (nur erster Monitor bei Multimonitoring)
	
	DWORD x, y, bpp;
	if (GetSteamResolution(&x, &y, &bpp));	//Steamauflsung aus Registry laden, ansonsten wird halt Desktop genommen
	{
		g_SpieleConfig.dmPelsWidth = x;
		g_SpieleConfig.dmPelsHeight = y;
		g_SpieleConfig.dmBitsPerPel = bpp;
		iDetection = 2;	
	}

	//Trayicon initialisieren
	::ZeroMemory(&Trayicon, sizeof(Trayicon));
	Trayicon.cbSize = sizeof(NOTIFYICONDATA);
	Trayicon.hWnd  = this->m_hWnd;
	Trayicon.uID = 1;
	Trayicon.uCallbackMessage = WM_TRAY_MESSAGE;	//die is in der .h defined
	Trayicon.hIcon = this->m_hIcon;
	strcpy(Trayicon.szTip, "GammaControl");
	Trayicon.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP;
	
	//Startparameter auswerten
	LPTSTR sParameter = GetCommandLine();

	m_bAutostart = !Autostart("check");
	
	if (strstr(sParameter, "noautostart") != NULL) Autostart("noauto");

	if (strstr(sParameter, "tray") != NULL)
		{
		m_bStartupvisible = false;
		m_bMinimized = true;
		Shell_NotifyIcon(NIM_ADD, &Trayicon);
		}
	else {
		m_bStartupvisible = true;
		m_bMinimized = false;
		}
	if ((strstr(sParameter, "altkey") != NULL))	iHotkey = 1;	//hier knenn nu quasi beliebig viele definiert werden	
	if ((strstr(sParameter, "shiftkey") != NULL))	iHotkey = 2;

	switch (iHotkey)		//Definition der Hotkeys
	{
	case 0:
		RegisterHotKey(this->m_hWnd,100,MOD_CONTROL|MOD_ALT,'1');	//STRG+ALT+Zahl
		RegisterHotKey(this->m_hWnd,200,MOD_CONTROL|MOD_ALT,'2');
		RegisterHotKey(this->m_hWnd,300,MOD_CONTROL|MOD_ALT,'3');
		RegisterHotKey(this->m_hWnd,400,MOD_CONTROL|MOD_ALT,'4');
		m_sHotkey = "STRG + ALT";
		break;
	case 1:
		RegisterHotKey(this->m_hWnd,100,MOD_ALT,'1');				//nur ALT+Zahl
		RegisterHotKey(this->m_hWnd,200,MOD_ALT,'2');
		RegisterHotKey(this->m_hWnd,300,MOD_ALT,'3');
		RegisterHotKey(this->m_hWnd,400,MOD_ALT,'4');
		m_sHotkey = "ALT";
		break;
	
	case 2:
		RegisterHotKey(this->m_hWnd,100,MOD_SHIFT,'1');				//nur Shift+Zahl
		RegisterHotKey(this->m_hWnd,200,MOD_SHIFT,'2');
		RegisterHotKey(this->m_hWnd,300,MOD_SHIFT,'3');
		RegisterHotKey(this->m_hWnd,400,MOD_SHIFT,'4');
		m_sHotkey = "SHIFT";
		break;
	}

	//Autoreset
	if ((strstr(sParameter, "autoreset") != NULL)) m_bAutoresetGamma = true;
	else m_bAutoresetGamma = false;

	if(strstr(sParameter, "gamma0") != NULL) {g_fNewgamma=(float)1.00-0*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma1") != NULL) {g_fNewgamma=(float)1.00-1*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma2") != NULL) {g_fNewgamma=(float)1.00-2*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma3") != NULL) {g_fNewgamma=(float)1.00-3*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma4") != NULL) {g_fNewgamma=(float)1.00-4*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma5") != NULL) {g_fNewgamma=(float)1.00-5*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma6") != NULL) {g_fNewgamma=(float)1.00-6*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma7") != NULL) {g_fNewgamma=(float)1.00-7*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma8") != NULL) {g_fNewgamma=(float)1.00-8*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma9") != NULL) {g_fNewgamma=(float)1.00-9*m_fGammastep;SetGamma(g_fNewgamma);};
	if(strstr(sParameter, "gamma10") != NULL) {g_fNewgamma=(float)1.00-10*m_fGammastep;SetGamma(g_fNewgamma);};
	
	//Auflsungsdetection Override
	if(strstr(sParameter, "640x480") != NULL) {g_SpieleConfig.dmPelsWidth = 640;g_SpieleConfig.dmPelsHeight = 480;iDetection = 3;};
	if(strstr(sParameter, "800x600") != NULL) {g_SpieleConfig.dmPelsWidth = 800;g_SpieleConfig.dmPelsHeight = 600;iDetection = 3;};
	if(strstr(sParameter, "1024x768") != NULL) {g_SpieleConfig.dmPelsWidth = 1024;g_SpieleConfig.dmPelsHeight = 768;iDetection = 3;};
	if(strstr(sParameter, "1280x1024") != NULL) {g_SpieleConfig.dmPelsWidth = 1280;g_SpieleConfig.dmPelsHeight = 1024;iDetection = 3;};
	if(strstr(sParameter, "1600x1200") != NULL) {g_SpieleConfig.dmPelsWidth = 1600;g_SpieleConfig.dmPelsHeight = 1200;iDetection = 3;};

	//Auflsungsinfo anzeigen
	char buffer[10];
	CStringArray sDetecion;
	sDetecion.Add("");
	sDetecion.Add("  (Desktop)");
	sDetecion.Add("  (Steam)");
	sDetecion.Add("  (Parameter)");

	ultoa(g_SpieleConfig.dmPelsWidth, &buffer[0], 10);
	m_sResolution = buffer + (CString)" x ";
	ultoa(g_SpieleConfig.dmPelsHeight, &buffer[0], 10);
	m_sResolution = m_sResolution + buffer + (CString)" x ";
	ultoa(g_SpieleConfig.dmBitsPerPel, &buffer[0], 10);
	m_sResolution = m_sResolution + buffer + sDetecion[iDetection];
	UpdateData(FALSE);
	
	if(TCHAR *stringposi = strstr(sParameter, "instantaction"))		//MOD-Start Feature
	{
		CString pfad = GetSteamPfad();
		CString params = GetSteamParameter(stringposi);
		if (pfad != "REGISTRYFEHLER" && params != "MODERROR")	//Wenn Registryeintrge ok und Mod erkannt, Execute
			{
			HINSTANCE h_starttest = ShellExecute(0, "open", pfad, params, "", SW_SHOWNORMAL);
			if ((int)h_starttest <= 32) MessageBox("Steam konnte nicht gestartet werden", "Fehler", MB_OK |MB_ICONSTOP);
			}
	}	
	return TRUE;
}

void CGammaManagerDlg::OnPaint()	//Standard MFC Classwizard Code ... ka ob man's wirklich braucht
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CGammaManagerDlg::OnQueryDragIcon()	//Standard MFC Classwizard Code ... ka ob man's wirklich braucht
{
	return (HCURSOR) m_hIcon;
}

void CGammaManagerDlg::SetGamma(float Gamma)	//Setzt die Gamma auf allen angeschlossenen Monitoren
{
	WORD ramp[256*3];

	for(int i = 0; i < 256; i++) {
		ramp[i] = ramp[i+256] = ramp[i+512] = 
		(WORD)min(65535, max(0, pow((i+1) / 256.0, Gamma) * 65535 + 0.5));
	}
    SetDeviceGammaRamp(::GetDC(NULL), ramp);
}

void CGammaManagerDlg::SetHz(UINT frequenz, DWORD aufloesung_x, DWORD aufloesung_y, DWORD farbtiefe)		//Setzt die Frequenz des 1. Monitors
{
	DEVMODE spiel;
	::ZeroMemory(&spiel, sizeof(spiel));
	spiel.dmDisplayFrequency = frequenz;
	spiel.dmSize = sizeof(spiel);
	spiel.dmPelsWidth = aufloesung_x;
	spiel.dmPelsHeight = aufloesung_y;
	spiel.dmBitsPerPel = farbtiefe;
	spiel.dmFields = DM_DISPLAYFREQUENCY|DM_PELSWIDTH|DM_PELSHEIGHT|DM_BITSPERPEL;	//Welche Felder gesetzt werden sollen
	ChangeDisplaySettings(&spiel, CDS_FULLSCREEN);			// 0 weil 1. Monitor
}

void CGammaManagerDlg::OnClose()				//Hotkeys sauber wieder entfernen .. CDS_FULLSCREEN setzt alles nach beenden zurck
{
	UnregisterHotKey(this->m_hWnd,100);							//Hotkey Cleanup
	UnregisterHotKey(this->m_hWnd,200);
	UnregisterHotKey(this->m_hWnd,300);
	UnregisterHotKey(this->m_hWnd,400);
	if(m_bMinimized) Shell_NotifyIcon(NIM_DELETE, &Trayicon);	//-tray Cleanup
	if(m_bAutoresetGamma) SetGamma((float)1.00);				//-autoreset Cleanup
	CDialog::OnClose();
}

void CGammaManagerDlg::OnAutostart()			//Wenn auf die Autostart Checkbox geklickt wird
{
	UpdateData(true);
	if (m_bAutostart == TRUE) Autostart("auto");
	else if (m_bAutostart == FALSE) Autostart("noauto");
}

void CGammaManagerDlg::OnTrayNotify(WPARAM wParam, LPARAM lParam)	//Klick aufs Trayicon
{
    UINT uID; 
    uID = (UINT) wParam;
    if (uID == 1)
	{
		UINT uMsg; 
		uMsg = (UINT) lParam; 
		if (uMsg == WM_LBUTTONDBLCLK ) MaximizeFromTray();	//Doppelklick der linken Maustaste aufs Trayicon
	}
}

void CGammaManagerDlg::OnSize(UINT nType, int cx, int cy)	//trigger: Ab-in-Traybar
{  
	if (nType == SIZE_MINIMIZED) MinimizeToTray();
	CWnd::OnSize(nType, cx, cy);  
}

void CGammaManagerDlg::MinimizeToTray()
{    
	BOOL bSuccess = Shell_NotifyIcon(NIM_ADD, &Trayicon);	//fgt das Trayicon hinzu
	if (!(bSuccess))    
	{        
		MessageBox("Kann Trayicon nicht setzen", "Error");  
	}    
	else 
	{
		this->ShowWindow(SW_MINIMIZE);   //minimiert und versteckt das Hauptfenster
		this->ShowWindow(SW_HIDE);   
		m_bMinimized = true;
	}
}

void CGammaManagerDlg::MaximizeFromTray()
{    
	m_bStartupvisible = true;
	Shell_NotifyIcon(NIM_DELETE, &Trayicon); 
	this->ShowWindow(SW_SHOW);			//zeigt das Hauptfenster wieder an
	this->ShowWindow(SW_RESTORE);   
	m_bMinimized = false;
}

void CGammaManagerDlg::OnWindowPosChanging(WINDOWPOS FAR* lpwndpos)		//"voidnish" von codeproject.com hats drauf ...
{
    if(!m_bStartupvisible) lpwndpos->flags &= ~SWP_SHOWWINDOW;

    CDialog::OnWindowPosChanging(lpwndpos);
}

CString CGammaManagerDlg::GetSteamPfad()	//Steam Pfad aus der registry lesen
{
	HKEY registryhandle;
	TCHAR steampfad[255];
	ULONG pfadlaenge = sizeof(steampfad);

	if (RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Valve\\Steam"), &registryhandle)) 
		strcpy(steampfad, "REGISTRYFEHLER");
	if (RegQueryValueEx(registryhandle, _T("SteamExe"), NULL, NULL, (LPBYTE)&steampfad, &pfadlaenge)) 
		strcpy(steampfad, "REGISTRYFEHLER");
	RegCloseKey(registryhandle);
	return steampfad;
}

bool CGammaManagerDlg::GetSteamResolution(DWORD *steamx, DWORD *steamy, DWORD *farbtiefe)	//von Steam gespeicherte Spielauflsung
{
	HKEY registryhandle;
	ULONG bufferlaenge = sizeof(steamx);

	if (RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Valve\\Half-Life\\Settings"), &registryhandle)) return false;
	if (RegQueryValueEx(registryhandle, _T("ScreenWidth"), NULL, NULL, (LPBYTE)steamx, &bufferlaenge)) return false;
	if (RegQueryValueEx(registryhandle, _T("ScreenHeight"), NULL, NULL, (LPBYTE)steamy, &bufferlaenge)) return false;
	if (RegQueryValueEx(registryhandle, _T("ScreenBPP"), NULL, NULL, (LPBYTE)farbtiefe, &bufferlaenge)) return false;
	RegCloseKey(registryhandle);
	return true;
}

CString CGammaManagerDlg::GetSteamParameter(TCHAR* Commandline)		// MOD Start Funktion
{
	if(strstr(Commandline, "cs")) return "-applaunch 10";					//CS 1.6
	else if(strstr(Commandline, "tfc")) return "-applaunch 20";			//Team Fortress Classic
	else if(strstr(Commandline, "dod")) return "-applaunch 30";			//Day of Defeat
	else if(strstr(Commandline, "dmc")) return "-applaunch 40";			//Deathmatch Classic
	else if(strstr(Commandline, "of")) return "-applaunch 50";			//Opposing Force
	else if(strstr(Commandline, "rico")) return "-applaunch 60";			//Ricochet
	else if(strstr(Commandline, "hl")) return "-applaunch 70";			//Half Life
	else if(strstr(Commandline, "sven")) return "-applaunch 70 -game svencoop";	//Sven COOP Mod
	else if(strstr(Commandline, "dgp")) return "-applaunch 70 -game dpb";	//Digital Paintball
	else if(strstr(Commandline, "cscz")) return "-applaunch 80";			//CS: Condition Zero
	else if(strstr(Commandline, "gordon")) return "-applaunch 92";		//Codename Gordon
	else if(strstr(Commandline, "csczd")) return "-applaunch 100";		//CS: Condition Zero Deleted Scenes
	else if(strstr(Commandline, "hl2")) return "-applaunch 220";			//Half Life 2
	else if(strstr(Commandline, "css")) return "-applaunch 240";			//CS: Source
	else if(strstr(Commandline, "hl2dm")) return "-applaunch 320";		//HL2: DM
	else if(strstr(Commandline, "steam")) return "";						//Steam only

	else return "MODERROR";		//Mod nicht erkannt
}

BOOL CGammaManagerDlg::Autostart(CString aktion)
{
	HKEY registryhandle;
	TCHAR gammacontrol[255];
	ULONG pfadlaenge = sizeof(gammacontrol);

	if(aktion == "check")	// Ist Gammacontrol bereits autostartend?
		{		
		RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), &registryhandle);
		if(RegQueryValueEx(registryhandle, _T("Gammacontrol"), NULL, NULL, (LPBYTE)&gammacontrol, &pfadlaenge) != ERROR_SUCCESS) 
			{
			RegCloseKey(registryhandle);
			return TRUE;
			}
		else 
			{
			RegCloseKey(registryhandle);
			return FALSE;
			}
		}

	else if(aktion == "auto")	// Starte mit Windows
		{
		LPTSTR sParameter = GetCommandLine();
		CString exepfad = sParameter;
		LPTSTR data = "";
		int laenge = exepfad.GetLength();
		strcpy(data, exepfad);

		RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), &registryhandle);
		RegSetValueEx(registryhandle, _T("Gammacontrol"), NULL, REG_SZ, (CONST BYTE*) data, laenge);
		RegCloseKey(registryhandle);
		return TRUE;
		}

	else if (aktion == "noauto")	// Starte nicht mit Windows
		{		
		RegOpenKey(HKEY_CURRENT_USER, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), &registryhandle);
		RegDeleteValue(registryhandle, _T("Gammacontrol"));
		RegCloseKey(registryhandle);
		return TRUE;
		}
	else return FALSE;
}

// Fngt Escape ab
void CGammaManagerDlg::OnCancel()
{
	OnClose();			//Cleanup
	EndDialog(IDOK);	//Beenden
}

// Fngt Return ab
void CGammaManagerDlg::OnOK()
{
	return;				//Taste Return luft nu ins Leere
}